#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int Nmax = 300;
pair<int, int> pr[Nmax];

struct edge {
    int to, ft, st, cost;
};

struct pnt {
    int v, t, cost;
};
bool operator<(pnt a, pnt b) {
    if(a.t == b.t)
        return a.cost > b.cost;
    return a.t > b.t;
}
vector<edge> g[Nmax];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    freopen("tax.in", "r", stdin);
    freopen("tax.out", "w", stdout);

    int n, m, s_t, s_a, s_b;
    cin >> n >> m >> s_t >> s_a >> s_b;

    s_a--, s_b--;

    stringstream s;
    string hS;
    getline(cin, hS);
    int a, b, c, t, prev;
    for(int i = 0;i < m;i++) {
        getline(cin, hS);
        s.clear();
        s.str(hS);
        s >> b >> prev >> c;
        b--;
        while(s >> a >> t >> c) {
            a--;
            g[b].push_back({a, prev, t, c});
            b = a;
            prev = t;
        }
    }
    for(int i = 0;i < n;i++)
        pr[i] = make_pair(1e9+9, 1e9+9);
    pair<int, int> min_cost = make_pair(1e9+9, 1e9+9), min_time = make_pair(1e9+9, 1e9+9);
    priority_queue<pnt> q;
    q.push({s_a, s_t, 0});
    pnt v;
    edge w;
    while(!q.empty()) {
        v = q.top();
        q.pop();
        if(v.cost > min_cost.second && v.t > min_time.first)
            continue;
        if(v.v == s_b) {
            if(v.cost < min_cost.second || v.cost == min_cost.second && v.t < min_cost.first)
                min_cost = {v.t, v.cost};
            if(v.t < min_time.first || v.t == min_time.first && v.cost < min_time.second)
                min_time = {v.t, v.cost};
        }
        for(int i = 0;i < g[v.v].size();i++) {
            w = g[v.v][i];
            if(v.t <= w.ft) {
                if(w.st <= pr[w.to].first || v.cost+w.cost <= pr[w.to].second) {
                    q.push({w.to, w.st, v.cost + w.cost});
                    pr[w.to] = make_pair(min(w.st, pr[w.to].first), min(v.cost+w.cost, pr[w.to].second));
                }
            }
            else if((v.t/1440+1)*1440 + w.st <= pr[w.to].first || v.cost+w.cost <= pr[w.to].second) {
                    q.push({w.to, (v.t/1440+1)*1440 + w.st, v.cost + w.cost});
                    pr[w.to] = make_pair(min((v.t/1440+1)*1440 + w.st, pr[w.to].first), min(v.cost+w.cost, pr[w.to].second));
                }

        }
    }
    cout << min_time.first << ' ' << min_time.second << '\n';
    cout << min_cost.first << ' ' << min_cost.second << '\n';
    return 0;
}
