/* GCC */
#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <vector>
#include <map>
#include <string>
#include <set>
#include <list>

using namespace std;

#define FilkinMaksim int main()
#define fast ios_base::sync_with_stdio(false);cin.tie(false);cout.tie(false)
#define f_in(s) freopen(s,"r",stdin);
#define f_out(s) freopen(s,"w",stdout);
#define pb push_back
#define mp make_pair
#define endl '\n'

const int nmax = 300;
const int mod = 1440;
const int inf = 1e9;

typedef pair<int,int> pii;

struct vertex
{
    int v_t,time_in,time_out,money;
};

vector <vertex> g[nmax];
list < pii > time_and_money[nmax];

FilkinMaksim
{
    fast;
    f_in("tax.in");
    f_out("tax.out");
    int n,m,t,a,b;
    pii min_time = mp(inf,inf);
    pii min_money = mp(inf,inf);
    cin >> n >> m >> t >> a >> b;
    a--; b--;
    int y,y1,x,x1,x2;
    while (cin >> x >> x1 >> x2)
    {
        x--;
        if (x2 != 0)
        {
            vertex temp;
            temp.v_t = x;
            temp.time_in = y1;
            temp.time_out = x1;
            temp.money = x2;
            g[y].pb(temp);
        }
        y = x;
        y1 = x1;
    }
    time_and_money[a].pb(mp(0,t));
    bool f = true;
    for (int i = 0; i < n && f; i++)
    {
        f = false;
        for (int j = 0; j < n; j++)
        {
            for (list< pii >::iterator v = time_and_money[j].begin(); v != time_and_money[j].end(); v++)
            {
                for (int k = 0; k < g[j].size(); k++)
                {
                    int vmoney = v->first;
                    int vtime = v->second;
                    if (vtime % mod > g[j][k].time_in) vtime = (vtime / mod + 1) * mod + g[j][k].time_out;
                    else vtime = vtime / mod * mod + g[j][k].time_out;
                    vmoney += g[j][k].money;
                    int next_vertex = g[j][k].v_t;
                    bool flag = true;
                    for(list<pair<int,int> >::iterator next_v = time_and_money[next_vertex].begin(); next_v != time_and_money[next_vertex].end();)
                    {
                        int t1 = next_v->first;
                        int t2 = next_v->second;
                        if (t1 <= vmoney && t2 <= vtime)
                        {
                            flag = false;
                            break;
                        }
                        if (t1 >= vmoney && t2 >= vtime)
                        {
                            next_v = time_and_money[next_vertex].erase(next_v);
                            continue;
                        }
                        next_v++;
                    }
                    if (flag)
                    {
                        f = true;
                        time_and_money[next_vertex].pb(mp(vmoney,vtime));
                    }
                }
            }
        }
    }
    for(list< pii >::iterator v = time_and_money[b].begin(); v != time_and_money[b].end(); v++)
    {
        int t1 = v->first;
        int t2 = v->second;
        if (t1 < min_money.first) min_money = mp(t1,t2);
        else if (t1 == min_money.first && t2 < min_money.second) min_money = mp(t1,t2);
        if (t2 < min_time.second) min_time = mp(t1,t2);
        else if (t2 == min_time.second && t1 < min_time.first) min_time = mp(t1,t2);
    }
    cout << min_time.second << ' ' << min_time.first << '\n';
    cout << min_money.second << ' ' << min_money.first << '\n';
}
