#include<iostream>
#include<cstdio>
#include<sstream>
#include<vector>

using namespace std;

struct node {
    node(){}
    node(int to, int from_time, int to_time, int cost):to(to), from_time(from_time), to_time(to_time), cost(cost){}
    int to, from_time, to_time, cost;
};

int main(){
    freopen("tax.in", "r", stdin);
    freopen("tax.out", "w", stdout);
    int n, m, t, a, b;
    vector< node > graf[250];
    vector< pair<int, int> > state[250];
    cin >> n >> m >> t >> a >> b;
    a--; b--;
    string line;
    getline(cin, line);
    for(int i = 0; i < m; i++){
        getline(cin, line);
        stringstream ss(line);
        int from = -1, to, from_time, to_time, cost;
        while(ss >> to >> to_time >> cost){
            --to;
            if(from != -1) graf[from].push_back(node(to, from_time, to_time, cost));
            from = to;
            from_time = to_time;
        }
    }
    state[a].push_back(make_pair(t, 0));
    bool updated = true;
    while(updated){
        updated = false;
        for(int v = 0; v < n; v++){
            for(int j = 0; j < state[v].size(); j++){
                int curr_time = state[v][j].first;
                int curr_cost = state[v][j].second;
                for(int i = 0; i < graf[v].size(); i++){
                    node now_node = graf[v][i];
                    int next_time = curr_time;
                    int next_cost = curr_cost + now_node.cost;
                    if(next_time % 1440 > now_node.from_time){
                        next_time  = (next_time / 1440 + 1) * 1440;
                    }
                    next_time = next_time / 1440 * 1440 + now_node.to_time;
                    bool to_insert = true;
                    int u = now_node.to;
                    for(int k = 0; k < state[u].size();){
                        if(state[u][k].first <= next_time && state[u][k].second <= next_cost){
                            to_insert = false;
                            break;
                        }
                        if(state[u][k].first >= next_time && state[u][k].second >= next_cost){
                            state[u].erase(state[u].begin() + k);
                        }
                        else k++;
                    }
                    if(to_insert){
                        updated = true;
                        state[u].push_back(make_pair(next_time, next_cost));
                    }
                }
            }
        }
    }
    pair<int, int> out_time = make_pair(2e9, 2e9), out_cost = make_pair(2e9, 2e9);
    for(int i = 0; i < state[b].size(); i++){
        if(out_time.first > state[b][i].first || (out_time.first == state[b][i].first && out_time.second > state[b][i].second)){
            out_time = state[b][i];
        }
        if(out_cost.second > state[b][i].second || (out_cost.second == state[b][i].second && out_cost.first > state[b][i].first)){
            out_cost = state[b][i];
        }
    }
    cout << out_time.first << ' ' << out_time.second << endl;
    cout << out_cost.first << ' ' << out_cost.second << endl;
}
