#include <iostream>
#include <vector>
#include <fstream>
#include <map>

using namespace std;

map <vector <bool>, bool> win;
map <vector <bool>, bool> visited;

int n = 1;

bool try_one(vector <bool> c, int a);
bool try_two(vector <bool> c, int a);

void print_it(vector <bool> cur){
    for(int i = 1; i <= n; i++){
        cout << cur[i] << " ";
    }
    cout << (win[cur] ? " Win!\n" : "Lose...\n");
}

void ptry(vector <bool> cur){
    cout << "Trying : ";
    int k = cur.size();
    for(int i = 1;i < k; i++){
        cout << cur[i] << " ";
    }
    cout << endl;
}

void ptry1(vector <bool> cur){
    cout << "Trying1 : ";
    int k = cur.size();
    for(int i = 1;i < k; i++){
        cout << cur[i] << " ";
    }
    cout << endl;
}

bool try_one(vector <bool> c, int a){
    vector <bool> cur = c;
    if(a != 0) cur[a] = 0;
    int cnt = 0;
  //  ptry1(cur);
    if(visited[cur]) return win[cur];
  //  cout << "going in1...\n";
    bool result = false;
    visited[cur] = 1;
    for(int i = 1; i < n; i++){
        if(cur[i] && cur[i+1]) cnt++, result = result | (!try_two(cur,i));
        if(cur[i]) cnt++, result = result | (!try_one(cur,i));
    }
    if(cur[n]) cnt++, result = result | (!try_one(cur,n));
    if(cnt == 0) result = 1;
    win[cur] = result;
 //   print_it(cur);
    return result;
}

bool try_two(vector <bool> c, int a){
    vector <bool> cur = c;
    int cnt = 0;
    if(a != 0) {
            cur[a] = 0;
            cur[a+1] = 0;
    }
 //   ptry(cur);
    if(visited[cur]) return win[cur];
  //  cout << "going in2...\n";
    bool result = false;
    visited[cur] = 1;
    for(int i = 1; i < n; i++){
        if(cur[i] && cur[i+1]) cnt++, result = result | (!try_two(cur,i));
        if(cur[i]) cnt++, result = result | (!try_one(cur,i));
    }
    if(cur[n]) cnt++, result = result | (!try_one(cur,n));
    if(cnt == 0) result = 1;
    win[cur] = result;
 //   print_it(cur);
    return result;
}


int main(){
    freopen("game.in","r",stdin);
    freopen("game.out","w", stdout);
    int a;
    vector <bool> cur;
    cur.push_back(1);
    cin.tie(0);
    cout.tie(0);
    while(cin >> a){
        while(a - n > 0) {
            cur.push_back(0);
            n++;
        }
        cur.push_back(1);
        n++;
    }
    n--;
 //   print_it(cur);
    bool temp = false;
    for(int i = 1; i <= n; i++){
        if(cur[i]) {
            temp = try_one(cur,i);
            if(!temp) cout << i << " ";
        }
        visited[cur] = 1;
    }
    cout << endl;
    for(int i = 1; i < n; i++){
        if(cur[i] && cur[i+1]) {
            temp = try_two(cur,i);
            if(!temp) cout << i << " ";
        }
        visited[cur] = 1;
    }
    cout << endl;
    return 0;
}
